#!/usr/bin/python3

from nmigen import *
from uart import *
from nmigen_boards.ice40_hx8k_b_evn import *

class Top(Elaboratable):

    def elaborate(self, platform):

        # PLL Stuff

        # If you don't specify dir='-', you will experience a world
        # of debugging pain.

        m = Module()
        timer = Signal(26)

        #Connect TX to B12
        muart = platform.request('uart')

        m.d.sync += [
            timer.eq(timer + 1)
        ]

        uart = UART(divisor=1250)
        uart.tx_o = muart.tx

        m.d.comb += [
            uart.tx_data.eq(0x61),
            uart.tx_rdy.eq(timer[-1])
        ]
        
        m.submodules += [uart] 

        return m


if __name__ == '__main__':
    platform = ICE40HX8KBEVNPlatform()

    platform.build(Top(), do_program=True)
